' Folder2csv.VBS V1.00 (C) yoshioka.teruo@nifty.com 2005-02-22
' Folder2csv.VBS output explorer file list details to CSV file
' Usage: cscript //nologo Folder2csv.VBS [/n|directory] >csvfile
'    /n: special folder id number
'    /?: lists special folder id number

Option Explicit
Dim Shell
Dim wShell
Dim fso
Dim argv()
Dim argc
Dim arg
Dim k
Dim Folder
Dim ie
Dim COL:COL=50

Set Shell=CreateObject("Shell.Application")
Set wShell=CreateObject("WScript.Shell")
Set fso=CreateObject("Scripting.FileSystemObject")
ReDim argv(WScript.Arguments.Count)
For Each arg In WScript.Arguments
  If arg="/?" Then
    Call SpecialFolders()
    WScript.Quit
  ElseIf Left(arg,1)="/" Then
    argv(argc)=CLng(Mid(arg,2))
  ElseIf Left(arg,2)="::" Or LCase(Left(arg,6))="shell:" Then
    argv(argc)=arg
  Else
    argv(argc)=fso.GetAbsolutePathName(arg)
  End If
  argc=argc+1
Next
If WScript.Arguments.Count=0 And _
   UCase(fso.GetBaseName(WScript.FullName))="CSCRIPT" Then
  argv(argc)=fso.GetAbsolutePathName("")
  argc=argc+1
End If

For k=0 To argc-1
  arg=argv(k)
  Set Folder=Shell.NameSpace(arg)
  If Folder Is Nothing Then
    WScript.Echo arg,"Is Not Found."
  Else
    Call FileList(arg,Folder)
  End If
Next

If WScript.Arguments.Count=0 And _
   UCase(fso.GetBaseName(WScript.FullName))="WSCRIPT" Then
  For Each ie In shell.Windows
    Set Folder=Nothing
    On Error Resume Next
    Set Folder=ie.Document.Folder
    On Error GoTo 0
    If Not (Folder Is Nothing) Then
      arg=ie.LocationURL
      If Left(arg,8)="file:///" Then
        arg=UnEscape(Replace(Mid(arg,9),"/","\"))
      End If
      If MsgBox("Process this folder?"&vbCrLf&_
                ie.LocationName&vbCrLf&arg,_
                vbOkCancel+vbDefaultButton2,_
                WScript.ScriptName)=vbOK Then
        Call FileList(ie.LocationName,Folder)
      End If
    End If
  Next
End If
WScript.Quit

Function FileList(arg,Folder)
Dim StdOut
Dim tFolder
Dim tName
Dim tPath
Dim tCOL
Dim k
Dim FolderItem
Dim FName()
Dim Value

Set FolderItem=Nothing
k=0
On Error Resume Next
Set FolderItem=Folder.Items.Item
k=Folder.Items.Count
On Error Goto 0
If FolderItem Is Nothing Then
  If k=0 Then
    WScript.Echo arg,"Is Not Folder."
  Else
    arg=Folder.Title
  End If
Else
  arg=FolderItem.Path
End If
If Left(arg,2)="::" Then arg=Folder.Title & " " & arg

If UCase(fso.GetBaseName(WScript.FullName))="CSCRIPT" Then
  Set StdOut=WScript.StdOut
Else
  Set tFolder=fso.GetSpecialFolder(2)
  tName=fso.GetBaseName(fso.GetTempName()) & ".CSV"
  tPath=fso.BuildPath(tFolder.Path,tName)
  Set StdOut=tFolder.CreateTextFile(tName)
End If

For tCOL=COL To 0 Step -1
  If Len(Folder.GetDetailsOf(,tCol))>0 Then Exit For
Next

ReDim FName(tCOL)
For k=0 To tCOL
  FName(k)=Folder.GetDetailsOf(,k)
  If Len(FName(k)) Then
    If Right(FName(k),2)="" Then FName(k)=FName(k)&":Date"
    If Right(FName(k),1)="" Then FName(k)=FName(k)&":Date"
    If FName(k)="TCY" Then FName(k)=FName(k)&" KB:Int"
  Else
    FName(k)=k
  End If
  StdOut.Write Pad(FName(k))
  If k<tCOL Then
    StdOut.Write ","
  Else
    StdOut.Write vbCRLF
  End If
Next

For Each FolderItem In Folder.Items
  For k=0 To tCOL
    Value=Folder.GetDetailsOf(FolderItem,k)
    If FName(k)="TCY KB:Int" Then Value=Replace(Value," KB","")
    StdOut.Write Pad(Value)
    If k<tCOL Then
      StdOut.Write ","
    Else
      StdOut.Write vbCRLF
    End If
  Next
Next

If UCase(fso.GetBaseName(WScript.FullName))="CSCRIPT" Then
Else
  StdOut.Close
  If MsgBox("Y - csvView.HTA"&vbCrLf&"N - NotePad.EXE",vbYesNo+vbDefaultButton2,"Open CSV file with ?")=vbYes Then 
    wShell.Run """"&Left(WScript.ScriptFullName,InStrRev(WScript.ScriptFullName,"\"))&"csvView.HTA"" """ &tPath&"""",,True
  Else
    wShell.Run "NotePad.EXE " & tPath,,True
  End If
  fso.DeleteFile tPath
End If
End Function

Function Pad(str)
If InStr(str,",") Then
  Pad="""" & Replace(str,"""","""""") & """"
'  Pad="""" & Replace(str,"""","h") & """"
Else
  Pad=str
End If
End Function

Sub SpecialFolders()
For k=1 To 50
  Set Folder=Shell.NameSpace(k)
  If Folder Is Nothing Then
  Else
    WScript.StdOut.WriteLine k
    WScript.StdOut.WriteLine Folder.Title
    WScript.StdOut.WriteLine Folder.Items.Item.Path
  End If
Next
End Sub
